//MODO DE USAR A CLASSE ENVIAREMAIL
//var
//xemail : tenviaremail;
//begin
//   xemail := TEnviarEmail.create(nil);
//   xemail.host := 'smtp.itelefonica.com.br';
//   xemail.De := 'saverio.vertoni@itelefonica.com.br';
//   xemail.para := 'saverio.vertoni@superig.com.br';
//   xemail.usuario := 'saverio.vertoni@itelefonica.com.br' ;
//   xemail.senha := 'abc123' ;
//   xemail.assunto :='tese';
//   xemail.texto := 'Digite aqui o texto do email';
//  if xemail.emailvalido('') then
//      xemail.enviar('texto.log');

//end;
unit uEnviarEmail;

interface

uses IdSMTP, IdMessage, IdText, IdAttachmentFile,
SysUtils,Classes,dialogs;

type
TEnviarEmail = class(TComponent)
    private
    LidSMTP: TIdSMTP;
    LIdMessage : TIdMessage;
    FHost: String;
    FDe: String;
    FPara: String;
    FAssunto: String;
    FSenha: String;
    FUsuario: String;
    FTipoDeAutenticacao: TidSMTPAuthenticationType;
    FTexto: String;
    FPorta: integer;
    procedure SetHost(const Value: String);
    procedure SetDe(const Value: String);
    procedure SetPara(const Value: String);
    procedure SetAssunto(const Value: String);
    procedure SetSenha(const Value: String);
    procedure SetUsuario(const Value: String);
    procedure SetTexto(const Value: String);
    procedure SetTipoDeAutenticacao(
      const Value: TidSMTPAuthenticationType);
    procedure SetPorta(const Value: integer);

  protected
   { protected declarations }
  public
   { public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Enviar(FileName: string): Boolean; virtual;
    class procedure mkMailExept(const Msg: String);
    property Host: String read FHost write SetHost;
    property De: String read FDe write SetDe;
    property Para: String read FPara write SetPara;
    property Assunto: String read FAssunto write SetAssunto;
    property Senha: String read FSenha write SetSenha;
    property Usuario: String read FUsuario write SetUsuario;
    property Texto: String read FTexto write SetTexto;
    property Porta: integer read FPorta write SetPorta default 25;
    property TipoDeAutenticacao: TidSMTPAuthenticationType read FTipoDeAutenticacao
write SetTipoDeAutenticacao default SatDefault;
    function EmailValido(const Email: String): Boolean;
  published
   { published declarations }
  end;
implementation


{ TEnviarEmail }

constructor TEnviarEmail.Create(AOwner: TComponent);
begin
  inherited;
  FTipoDeAutenticacao := SatDefault;
  FPorta := 25

end;

destructor TEnviarEmail.Destroy;
begin
  inherited;
  FreeAndNil(LIdMessage);
  FreeAndNil(LidSMTP);
inherited;
  end;

function TEnviarEmail.EmailValido(const Email: String): Boolean;
var
vEmail: String;
begin
Result := False;
vEmail := Trim(Email);

//Se for vazio e o e-mail principal tiver preenchido deixa passar.
if (vEmail = '') and (FPara <> '') then
begin
Result := True;
Exit;
end;//if

if Length(vEmail) < 8 then
mkMailExept('E-mail ''' + Email + ''' invlido.');

if Pos('@', vEmail) = 0 then
mkMailExept('E-mail ''' + Email + ''' invlido. Faltando ''@''');

if Pos('@', vEmail) < 3 then
mkMailExept('E-mail ''' + Email + ''' invlido. ''@'' est em posio invlida.');

if Pos('@', vEmail) > Length(vEmail) - 3 then
mkMailExept('E-mail ''' + Email + ''' invlido. ''@'' est em posio invlida.');
Result := True;
end;

function TEnviarEmail.Enviar(FileName: string): Boolean;
begin
  Result   := False;
  LidSMTP   := TIdSMTP.Create(nil);
  while not (LidSMTP.Connected) do   // enquanto no conectar, o programa vai ficar tentando conectar infinitamente.
  begin
    try

      LidSMTP.Disconnect;
      LidSMTP.Host          := host;
      LidSMTP.Port          := Fporta;
      LidSMTP.Username      := usuario;
      LidSMTP.Password      := senha;

      LidSMTP.AuthType   := FTipoDeAutenticacao;
      LidSMTP.Connect;
      if not LidSMTP.Connected then
        Exit;

      LIdMessage := TIdMessage.Create(nil);
      try
        LIdMessage.From.Text                   := fde;
        LIdMessage.Recipients.EMailAddresses   := fpara;
        LIdMessage.MessageParts.Clear;
        {:Foi criado para enviar a mensagem que esta na descricao}

        LIdMessage.Body.Text := texto;

				if FileExists(filename) then
					begin
            {:Este  para anexar arquivos no indy10 dechar no uses IdAttachmentFile}
            TIdAttachmentFile.Create(LIdMessage.MessageParts,fileName);
          end;

        LIdMessage.Subject       := Assunto;//Subject; //File_Name + ' em ' + FormatDateTime('dd/mm/yyyy hh:mm', Now);
        LIdMessage.Priority      := mpHighest;
        LidSMTP.Send(LIdMessage);
        {:Modificado por Adriano - Estou verificando se retorna alguma mensagem de volta para meu e-mail}
        LIdMessage.Headers.Values['Return-Receipt-To'] := fpara;
        LIdMessage.Headers.Add('disposition-notification-to: <FSMTP_From>');
 //       LIdMessage.SaveToFile('c:\LogErros.txt');
        {:Fim da modificao}
        Result := True;
      finally
        FreeAndNil(LidMessage);
        LIdMessage.Free;
      end;
    except
      {No conseguiu conectar, tenta conectar novamente em 1 minuto}
      Sleep(1000);
      Continue;
    end;
  end;
    LidSMTP.Disconnect;
    FreeAndNil(LidSMTP);
    LidSMTP.Free;
end;

class procedure TEnviarEmail.mkMailExept(const Msg: String);
begin
raise Exception.Create(Msg);
end;

procedure TEnviarEmail.SetAssunto(const Value: String);
begin
  if Trim(Value) = '' then
    mkMailExept('O ''Assunto'' deve ser informado.');
  if FAssunto <> Value then
    FAssunto := Value;
end;


procedure TEnviarEmail.SetDe(const Value: String);
var
vDe: String;
begin
  vDe := LowerCase(Value);
  if EmailValido(vDe) then
  if FDe <> vDe then
    FDe := vDe;
end;

procedure TEnviarEmail.SetHost(const Value: String);
begin
  if Trim(Value) = '' then
    mkMailExept('O ''host'' deve ser informado.');
  if FHost <> Value then
    FHost := Value;
end;

procedure TEnviarEmail.SetPara(const Value: String);
var
vPara: String;
begin
vPara := LowerCase(Value);
if EmailValido(vPara) then
if FPara <> vPara then
FPara := vPara;
end;

procedure TEnviarEmail.SetPorta(const Value: integer);
begin
if FPorta <> Value then
  FPorta := Value;
end;

procedure TEnviarEmail.SetSenha(const Value: String);
begin
if (Trim(Value) = '') then
mkMailExept('A Senha de ser informada quando exige autenticao.');
if FSenha <> Value then
begin
FSenha := Value;
end;
end;

procedure TEnviarEmail.SetTexto(const Value: String);
begin
if Trim(Value) = '' then
mkMailExept('O texto da Mensagem precisa ser informado.');
if FTexto <> Value then
FTexto := Value;
end;

procedure TEnviarEmail.SetTipoDeAutenticacao(
  const Value: TidSMTPAuthenticationType);
begin
if FTipoDeAutenticacao <> Value then
FTipoDeAutenticacao := Value;
end;

procedure TEnviarEmail.SetUsuario(const Value: String);
begin
if Trim(Value) = '' then
mkMailExept('O ''Usurio'' deve ser informado.');
if FUsuario <> Value then
FUsuario := Value;
end;

end.


